import * as React from 'react';
import classNames from 'classnames';
import { DASH } from '../../constants';
import CamelCaseWrap from '../utils/camel-case-wrap';
const StatusIconAndText = ({ icon, title, spin, iconOnly, noTooltip, className, }) => {
    if (!title) {
        return React.createElement(React.Fragment, null, DASH);
    }
    return (React.createElement("span", { className: classNames('co-icon-and-text', className), title: iconOnly && !noTooltip ? title : undefined },
        icon &&
            React.cloneElement(icon, {
                className: classNames(spin && 'fa-spin', icon.props.className, !iconOnly && 'co-icon-and-text__icon co-icon-flex-child'),
            }),
        !iconOnly && React.createElement(CamelCaseWrap, { value: title, dataTest: "status-text" })));
};
export default StatusIconAndText;
//# sourceMappingURL=StatusIconAndText.js.map